diff -u -Naur eperl-2.2.14/mod/Apache/ePerl.pm eperl-2.2.14.fink/mod/Apache/ePerl.pm
--- eperl-2.2.14/mod/Apache/ePerl.pm	Sun Aug  2 09:22:28 1998
+++ eperl-2.2.14.fink/mod/Apache/ePerl.pm	Wed Nov 17 12:45:58 2004
@@ -127,8 +127,8 @@
                 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec' );
     my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) =
         localtime($time);
-    my ($str) = sprintf("%s %s %2d %02d:%02d:%02d 19%s%s",
-                        $dow[$wday], $moy[$mon], $mday, $hour, $min, $sec, $year,
+    my ($str) = sprintf("%s %s %2d %02d:%02d:%02d %s%s",
+                        $dow[$wday], $moy[$mon], $mday, $hour, $min, $sec, $year+1900,
                         $isdst ?  " DST" : "");
     return $str;
 }
@@ -136,8 +136,8 @@
     my ($time) = @_;
     my ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) =
         localtime($time);
-    my ($str) = sprintf("%02d-%02d-19%02d %02d:%02d",
-                        $mday, $mon+1, $year, $hour, $min);
+    my ($str) = sprintf("%02d-%02d-%04d %02d:%02d",
+                        $mday, $mon+1, $year+1900, $hour, $min);
     return $str;
 }
 
@@ -181,12 +181,43 @@
     $mtime = $S[9];
     $owner = (getpwuid($S[4]))[0] || 'UNKNOWN';
 
+    my $uri = $r->uri;
+    # turn into a package name, borrowed from great Apache::Registry
+    $r->log_error(sprintf "Apache::ePerl::handler examining %s",
+              $uri) if $Debug;
+    my $path_info = $r->path_info;
+    my $script_name = $path_info && $uri =~ /\Q$path_info\E$/ ?
+        substr($uri, 0, length($uri)-length($path_info)) :
+        $uri;
+
+    $script_name =~ s:/+$:/__INDEX__:;
+
+    if ($Apache::ePerl::NameWithVirtualHost && $r->server->is_virtual) {
+        my $name = $r->get_server_name;
+        $script_name = join "", $name, $script_name if $name;
+    }
+
+    # Escape everything into valid perl identifiers
+    $script_name =~ s/([^A-Za-z0-9_\/])/sprintf("_%2x",unpack("C",$1))/eg;
+
+    # second pass cares for slashes and words starting with a digit
+    $script_name =~ s{
+              (/+)       # directory
+              (\d?)      # package's first character
+             }[
+               "::" . (length $2 ? sprintf("_%2x",unpack("C",$2)) : "")
+              ]egx;
+
+    my $package = "Apache::EPERLCACHE$script_name";
+    $r->log_error("Apache::ePerl::handler package $package")
+       if $Debug;
+
     #   check cache for existing P-code
-    if (not (    $Cache->{$filename} 
-             and $Cache->{$filename}->{CODE}
-             and $Cache->{$filename}->{SIZE}  == $size
-             and $Cache->{$filename}->{MTIME} == $mtime
-             and $Cache->{$filename}->{OWNER} eq $owner)) {
+    if (not (    $Cache->{$package}
+             and $Cache->{$package}->{CODE}
+             and $Cache->{$package}->{SIZE}  == $size
+             and $Cache->{$package}->{MTIME} == $mtime
+             and $Cache->{$package}->{OWNER} eq $owner)) {
         #   read script
         local ($/) = undef;
         $fh = new FileHandle $filename;
@@ -219,6 +250,14 @@
             return OK;
         }
 
+        $data = join(
+                '',
+                'package ',
+                $package,
+                ';use Apache qw(exit);',
+                $data
+               );
+
         #   precompile the source into P-code
         $error = '';
         if (not Parse::ePerl::Precompile({
@@ -234,15 +273,15 @@
         }
 
         #   set the new results
-        $Cache->{$filename} = {};
-        $Cache->{$filename}->{CODE}  = $data;
-        $Cache->{$filename}->{SIZE}  = $size;
-        $Cache->{$filename}->{MTIME} = $mtime;
-        $Cache->{$filename}->{OWNER} = $owner;
+        $Cache->{$package} = {};
+        $Cache->{$package}->{CODE}  = $data;
+        $Cache->{$package}->{SIZE}  = $size;
+        $Cache->{$package}->{MTIME} = $mtime;
+        $Cache->{$package}->{OWNER} = $owner;
     }
   
     #   retrieve precompiled script from cache
-    $data = $Cache->{$filename}->{CODE};
+    $data = $Cache->{$package}->{CODE};
 
     #   create runtime environment
     %env = $r->cgi_env;
diff -u -Naur eperl-2.2.14/mod/Parse/ePerl.pm eperl-2.2.14.fink/mod/Parse/ePerl.pm
--- eperl-2.2.14/mod/Parse/ePerl.pm	Sun Aug  2 09:22:28 1998
+++ eperl-2.2.14.fink/mod/Parse/ePerl.pm	Wed Nov 17 12:45:58 2004
@@ -87,6 +87,8 @@
 
     #   set defaults
     $p->{INC} ||= [ '.' ];
+    $p->{BeginDelimiter}  ||= '<:';
+    $p->{EndDelimiter}    ||= ':>';
 
     #   switch to directory of file
     if ($p->{Cwd}) {
@@ -98,7 +100,9 @@
     #   use XS part: PP (preprocessor)
     $result = PP(
         $p->{Script}, 
-        $p->{INC}
+        $p->{INC},
+        $p->{BeginDelimiter},
+        $p->{EndDelimiter}
     );
 
     #   restore Cwd
@@ -396,6 +400,14 @@
 =item I<Result>
 
 Reference to scalar receiving the resulting script in bristled Perl format.
+
+=item I<BeginDelimiter>
+
+Scalar specifying the begin delimiter.  Default is ``C<E<lt>:>''.
+
+=item I<EndDelimiter>
+
+Scalar specifying the end delimiter.  Default is ``C<:E<gt>>''.
 
 =item I<INC>
 
diff -u -Naur eperl-2.2.14/mod/Parse/ePerl.xs eperl-2.2.14.fink/mod/Parse/ePerl.xs
--- eperl-2.2.14/mod/Parse/ePerl.xs	Sat Apr  4 07:24:17 1998
+++ eperl-2.2.14.fink/mod/Parse/ePerl.xs	Wed Nov 17 12:45:58 2004
@@ -88,10 +88,12 @@
 ##  $buffer = Parse::ePerl::PP($buffer, \@INC);
 ##
 void
-PP(cpIn, avpsvpINC)
+PP(cpIn, avpsvpINC, cpBegin = "<:", cpEnd = ":>")
     char *cpIn;
+    char *cpBegin;
+    char *cpEnd;
     SV *avpsvpINC;
-PROTOTYPE: $$
+PROTOTYPE: $$;$$
 PPCODE:
 {
     SV *sv;
@@ -102,6 +104,9 @@
     int n;
     int i;
     STRLEN l;
+
+    ePerl_begin_delimiter           = cpBegin;
+    ePerl_end_delimiter             = cpEnd;
 
     if (!SvROK(avpsvpINC))
         croak("arg2 is not of reference type");
